From 2dd56e50d4e22a931b6b26de35a19321ee0e36a4 Mon Sep 17 00:00:00 2001
From: "shraddha.joshi@oracle.com" <shrajosh@low.us.oracle.com>
Date: Mon, 21 Nov 2016 12:10:24 -0800
Subject: [PATCH] Solaris-v1.10.3

---
 Dockerfile.solaris                                 |   26 +
 Makefile                                           |   35 +-
 api/client/run.go                                  |    1 +
 api/client/version.go                              |   20 -
 api/server/router/container/container_routes.go    |    7 +
 api/server/server_unix.go                          |    2 +-
 container/container_solaris.go                     |  650 ++++++++++++
 container/monitor.go                               |    9 +
 container/state_solaris.go                         |    9 +
 contrib/docker-device-tool/device_tool.go          |    2 +-
 contrib/httpserver/Dockerfile                      |    2 +-
 contrib/mkimage.sh                                 |   11 +
 contrib/mkimage/solaris                            |  120 +++
 daemon/commit.go                                   |   22 +-
 daemon/config.go                                   |    4 +
 daemon/config_solaris.go                           |   66 ++
 daemon/config_test.go                              |   30 +-
 daemon/container_operations_solaris.go             |  973 ++++++++++++++++++
 daemon/daemon.go                                   |    6 +-
 daemon/daemon_solaris.go                           |  576 +++++++++++
 daemon/daemon_test.go                              |    2 +
 daemon/daemon_unix_test.go                         |    2 +-
 daemon/daemon_unsupported.go                       |    2 +-
 daemon/daemonbuilder/builder_unix.go               |    2 +-
 daemon/debugtrap_unsupported.go                    |    2 +-
 daemon/exec_solaris.go                             |   18 +
 daemon/execdriver/driver_solaris.go                |   76 ++
 daemon/execdriver/driver_unix.go                   |    2 +-
 .../execdriver/execdrivers/execdrivers_solaris.go  |   13 +
 daemon/execdriver/zones/driver.go                  |  799 +++++++++++++++
 daemon/execdriver/zones/driver_unsupported.go      |   12 +
 .../execdriver/zones/driver_unsupported_nocgo.go   |   13 +
 daemon/graphdriver/driver_solaris.go               |    8 +
 daemon/graphdriver/driver_unsupported.go           |    2 +-
 daemon/graphdriver/graphtest/graphtest_unix.go     |    2 +-
 daemon/graphdriver/register/register_zfs.go        |    2 +-
 daemon/graphdriver/zfs/zfs.go                      |   47 +-
 daemon/graphdriver/zfs/zfs_freebsd.go              |   36 +
 daemon/graphdriver/zfs/zfs_linux.go                |   37 +
 daemon/graphdriver/zfs/zfs_solaris.go              |   95 ++
 daemon/graphdriver/zfs/zfs_unsupported.go          |    2 +-
 daemon/info.go                                     |    2 -
 daemon/inspect_solaris.go                          |   30 +
 daemon/inspect_unix.go                             |    2 +-
 daemon/list_unix.go                                |    2 +-
 daemon/network.go                                  |    7 +
 daemon/selinux_unsupported.go                      |    8 +
 daemon/start.go                                    |   16 +
 daemon/stats_collector_solaris.go                  |  537 ++++++++++
 daemon/stats_collector_unix.go                     |    2 +-
 daemon/stats_solaris.go                            |   84 ++
 docker/daemon_solaris.go                           |   58 ++
 docker/daemon_unix.go                              |    2 +-
 hack/.vendor-helpers.sh                            |    8 +-
 hack/make.sh                                       |   14 +-
 hack/make/.detect-daemon-osarch                    |   20 +-
 hack/make/.ensure-httpserver                       |    2 +-
 hack/make/.integration-daemon-setup                |    6 +-
 hack/make/.integration-daemon-start                |    9 +-
 integration-cli/docker_api_build_test.go           |    4 +-
 integration-cli/docker_api_events_test.go          |    4 +-
 integration-cli/docker_api_exec_test.go            |    6 +-
 integration-cli/docker_api_inspect_test.go         |   14 +-
 integration-cli/docker_api_volumes_test.go         |    4 +-
 integration-cli/docker_cli_attach_unix_test.go     |    2 +-
 integration-cli/docker_cli_authz_unix_test.go      |    2 +-
 integration-cli/docker_cli_build_test.go           |    2 +-
 integration-cli/docker_cli_build_unix_test.go      |    2 +-
 integration-cli/docker_cli_create_test.go          |    4 +-
 integration-cli/docker_cli_daemon_test.go          |   14 +
 integration-cli/docker_cli_events_test.go          |    4 +-
 integration-cli/docker_cli_events_unix_test.go     |   54 +-
 integration-cli/docker_cli_exec_unix_test.go       |    2 +-
 integration-cli/docker_cli_images_test.go          |    8 +-
 integration-cli/docker_cli_inspect_test.go         |   24 +-
 integration-cli/docker_cli_links_test.go           |    2 +
 integration-cli/docker_cli_links_unix_test.go      |    2 +-
 integration-cli/docker_cli_network_unix_test.go    |    2 +-
 integration-cli/docker_cli_ps_test.go              |   15 +-
 integration-cli/docker_cli_run_test.go             |  341 +++---
 integration-cli/docker_cli_run_unix_test.go        |   49 +-
 integration-cli/docker_cli_save_load_unix_test.go  |    2 +-
 .../docker_cli_start_volume_driver_unix_test.go    |   16 +-
 .../docker_cli_volume_driver_compat_unix_test.go   |    4 +-
 integration-cli/docker_cli_volume_test.go          |   12 +-
 integration-cli/docker_cli_wait_test.go            |    4 +-
 integration-cli/docker_test_vars.go                |    2 +-
 integration-cli/docker_utils.go                    |    2 +-
 integration-cli/test_vars_unix.go                  |    4 +-
 layer/layer_unix.go                                |    2 +-
 migrate/v1/migratev1_test.go                       |    2 +
 opts/hosts.go                                      |    3 -
 opts/hosts_solaris.go                              |   10 +
 opts/hosts_test.go                                 |    4 +-
 opts/hosts_unix.go                                 |    6 +-
 pkg/archive/archive_test.go                        |   38 +-
 pkg/archive/changes_test.go                        |   12 +-
 pkg/chrootarchive/archive_test.go                  |   54 +-
 pkg/chrootarchive/diff_unix.go                     |    1 -
 pkg/directory/directory_unix.go                    |    2 +-
 pkg/fileutils/fileutils_solaris.go                 |    7 +
 pkg/integration/utils_test.go                      |   11 +-
 pkg/mount/flags_solaris.go                         |   42 +
 pkg/mount/flags_unsupported.go                     |    2 +-
 pkg/mount/mount.go                                 |    3 +-
 pkg/mount/mount_test.go                            |    2 +
 pkg/mount/mounter_solaris.go                       |   33 +
 pkg/mount/mounter_unsupported.go                   |    2 +-
 pkg/mount/mountinfo_solaris.go                     |   35 +
 pkg/mount/mountinfo_unsupported.go                 |    2 +-
 pkg/parsers/kernel/uname_solaris.go                |   14 +
 pkg/parsers/kernel/uname_unsupported.go            |    2 +-
 .../operatingsystem/operatingsystem_solaris.go     |   33 +
 pkg/platform/architecture_solaris.go               |   16 +
 pkg/proxy/network_proxy_test.go                    |   40 +-
 pkg/reexec/command_solaris.go                      |   23 +
 pkg/reexec/command_unsupported.go                  |    2 +-
 pkg/signal/signal_solaris.go                       |   42 +
 pkg/signal/signal_unsupported.go                   |    2 +-
 pkg/sysinfo/sysinfo_solaris.go                     |  117 +++
 pkg/system/meminfo_solaris.go                      |  127 +++
 pkg/system/meminfo_unsupported.go                  |    2 +-
 pkg/system/stat_linux.go                           |   33 -
 pkg/system/stat_solaris.go                         |   20 +-
 pkg/system/stat_unix.go                            |   35 +
 pkg/system/stat_unsupported.go                     |    2 +-
 pkg/term/tc_other.go                               |    1 +
 pkg/term/tc_solaris_cgo.go                         |   60 ++
 pkg/term/term.go                                   |   22 -
 pkg/term/term_solaris.go                           |   39 +
 pkg/term/term_unix.go                              |   27 +
 registry/auth_test.go                              |    2 +
 registry/registry_mock_test.go                     |    2 +
 registry/registry_test.go                          |    2 +
 runconfig/hostconfig_solaris.go                    |   82 ++
 runconfig/hostconfig_unix.go                       |    1 +
 runconfig/opts/parse.go                            |    2 +
 .../github.com/Sirupsen/logrus/terminal_solaris.go |   15 +
 .../docker/engine-api/types/container/config.go    |    4 +
 .../engine-api/types/container/host_config.go      |    1 +
 .../github.com/docker/engine-api/types/types.go    |    2 -
 .../docker/go-connections/sockets/unix_socket.go   |    2 +-
 .../docker/libnetwork/default_gateway_solaris.go   |    7 +
 .../libnetwork/drivers/solaris/bridge/bridge.go    | 1084 ++++++++++++++++++++
 .../drivers/solaris/bridge/bridge_store.go         |  212 ++++
 .../libnetwork/drivers/solaris/bridge/errors.go    |  341 ++++++
 .../drivers/solaris/bridge/port_mapping.go         |  247 +++++
 .../docker/libnetwork/drivers_solaris.go           |   13 +
 .../docker/libnetwork/ipamutils/utils_solaris.go   |   92 ++
 vendor/src/github.com/docker/libnetwork/network.go |    2 -
 .../docker/libnetwork/osl/interface_solaris.go     |    6 +
 .../docker/libnetwork/osl/namespace_solaris.go     |   41 +
 .../docker/libnetwork/osl/namespace_unsupported.go |    2 +-
 .../docker/libnetwork/osl/neigh_solaris.go         |    6 +
 .../docker/libnetwork/osl/sandbox_unsupported.go   |    2 +-
 .../libnetwork/portallocator/portallocator.go      |   22 -
 .../portallocator/portallocator_linux.go           |   28 +
 .../portallocator/portallocator_solaris.go         |    5 +
 .../docker/libnetwork/portmapper/mapper.go         |  228 ----
 .../docker/libnetwork/portmapper/mapper_linux.go   |  228 ++++
 .../docker/libnetwork/portmapper/mapper_solaris.go |  150 +++
 .../docker/libnetwork/portmapper/mock_proxy.go     |   18 -
 .../libnetwork/portmapper/mock_proxy_linux.go      |   18 +
 .../docker/libnetwork/portmapper/proxy.go          |  209 ----
 .../docker/libnetwork/portmapper/proxy_linux.go    |  209 ++++
 vendor/src/github.com/docker/libnetwork/sandbox.go |    7 +-
 .../libnetwork/sandbox_externalkey_solaris.go      |   45 +
 .../docker/libnetwork/sandbox_externalkey_unix.go  |    2 +-
 .../src/github.com/godbus/dbus/transport_unix.go   |    2 +-
 vendor/src/github.com/kr/pty/ioctl.go              |    2 +
 vendor/src/github.com/kr/pty/util.go               |   11 -
 vendor/src/github.com/mistifyio/go-zfs/utils.go    |   82 +-
 .../mistifyio/go-zfs/utils_notsolaris.go           |   82 ++
 .../github.com/mistifyio/go-zfs/utils_solaris.go   |   85 ++
 vendor/src/github.com/mistifyio/go-zfs/zfs.go      |   86 +-
 .../github.com/mistifyio/go-zfs/zfs_notsolaris.go  |   80 ++
 .../src/github.com/mistifyio/go-zfs/zfs_solaris.go |   87 ++
 vendor/src/github.com/mistifyio/go-zfs/zpool.go    |   37 +-
 .../mistifyio/go-zfs/zpool_notsolaris.go           |   33 +
 .../github.com/mistifyio/go-zfs/zpool_solaris.go   |   40 +
 .../runc/libcontainer/configs/cgroup_solaris.go    |    6 +
 .../libcontainer/configs/cgroup_unsupported.go     |    2 +-
 .../runc/libcontainer/configs/device_defaults.go   |    4 +-
 .../runc/libcontainer/console_solaris.go           |   13 +
 .../runc/libcontainer/container_solaris.go         |   22 +
 .../runc/libcontainer/stats_solaris.go             |    8 +
 .../runc/libcontainer/system/sysconfig.go          |    2 +-
 .../runc/libcontainer/zones/stats.go               |   86 ++
 vendor/src/gopkg.in/fsnotify.v1/fen.go             |  188 ++++
 vendor/src/gopkg.in/fsnotify.v1/fen_cgo.go         |   82 ++
 vendor/src/gopkg.in/fsnotify.v1/fsnotify.go        |    2 +-
 volume/local/local_unix.go                         |    2 +-
 volume/store/store_unix.go                         |    2 +-
 193 files changed, 9237 insertions(+), 1241 deletions(-)
 create mode 100644 Dockerfile.solaris
 create mode 100644 container/container_solaris.go
 create mode 100644 container/state_solaris.go
 create mode 100755 contrib/mkimage/solaris
 create mode 100644 daemon/config_solaris.go
 create mode 100644 daemon/container_operations_solaris.go
 create mode 100644 daemon/daemon_solaris.go
 create mode 100644 daemon/exec_solaris.go
 create mode 100644 daemon/execdriver/driver_solaris.go
 create mode 100644 daemon/execdriver/execdrivers/execdrivers_solaris.go
 create mode 100644 daemon/execdriver/zones/driver.go
 create mode 100644 daemon/execdriver/zones/driver_unsupported.go
 create mode 100644 daemon/execdriver/zones/driver_unsupported_nocgo.go
 create mode 100644 daemon/graphdriver/driver_solaris.go
 create mode 100644 daemon/graphdriver/zfs/zfs_solaris.go
 create mode 100644 daemon/inspect_solaris.go
 create mode 100644 daemon/stats_collector_solaris.go
 create mode 100644 daemon/stats_solaris.go
 create mode 100644 docker/daemon_solaris.go
 create mode 100644 opts/hosts_solaris.go
 create mode 100644 pkg/fileutils/fileutils_solaris.go
 create mode 100644 pkg/mount/flags_solaris.go
 create mode 100644 pkg/mount/mounter_solaris.go
 create mode 100644 pkg/mount/mountinfo_solaris.go
 create mode 100644 pkg/parsers/kernel/uname_solaris.go
 create mode 100644 pkg/parsers/operatingsystem/operatingsystem_solaris.go
 create mode 100644 pkg/platform/architecture_solaris.go
 create mode 100644 pkg/reexec/command_solaris.go
 create mode 100644 pkg/signal/signal_solaris.go
 create mode 100644 pkg/sysinfo/sysinfo_solaris.go
 create mode 100644 pkg/system/meminfo_solaris.go
 delete mode 100644 pkg/system/stat_linux.go
 create mode 100644 pkg/system/stat_unix.go
 create mode 100644 pkg/term/tc_solaris_cgo.go
 create mode 100644 pkg/term/term_solaris.go
 create mode 100644 pkg/term/term_unix.go
 create mode 100644 runconfig/hostconfig_solaris.go
 create mode 100644 vendor/src/github.com/Sirupsen/logrus/terminal_solaris.go
 create mode 100644 vendor/src/github.com/docker/libnetwork/default_gateway_solaris.go
 create mode 100644 vendor/src/github.com/docker/libnetwork/drivers/solaris/bridge/bridge.go
 create mode 100644 vendor/src/github.com/docker/libnetwork/drivers/solaris/bridge/bridge_store.go
 create mode 100644 vendor/src/github.com/docker/libnetwork/drivers/solaris/bridge/errors.go
 create mode 100644 vendor/src/github.com/docker/libnetwork/drivers/solaris/bridge/port_mapping.go
 create mode 100644 vendor/src/github.com/docker/libnetwork/drivers_solaris.go
 create mode 100644 vendor/src/github.com/docker/libnetwork/ipamutils/utils_solaris.go
 create mode 100644 vendor/src/github.com/docker/libnetwork/osl/interface_solaris.go
 create mode 100644 vendor/src/github.com/docker/libnetwork/osl/namespace_solaris.go
 create mode 100644 vendor/src/github.com/docker/libnetwork/osl/neigh_solaris.go
 create mode 100644 vendor/src/github.com/docker/libnetwork/portallocator/portallocator_linux.go
 create mode 100644 vendor/src/github.com/docker/libnetwork/portallocator/portallocator_solaris.go
 delete mode 100644 vendor/src/github.com/docker/libnetwork/portmapper/mapper.go
 create mode 100644 vendor/src/github.com/docker/libnetwork/portmapper/mapper_linux.go
 create mode 100644 vendor/src/github.com/docker/libnetwork/portmapper/mapper_solaris.go
 delete mode 100644 vendor/src/github.com/docker/libnetwork/portmapper/mock_proxy.go
 create mode 100644 vendor/src/github.com/docker/libnetwork/portmapper/mock_proxy_linux.go
 delete mode 100644 vendor/src/github.com/docker/libnetwork/portmapper/proxy.go
 create mode 100644 vendor/src/github.com/docker/libnetwork/portmapper/proxy_linux.go
 create mode 100644 vendor/src/github.com/docker/libnetwork/sandbox_externalkey_solaris.go
 create mode 100644 vendor/src/github.com/mistifyio/go-zfs/utils_notsolaris.go
 create mode 100644 vendor/src/github.com/mistifyio/go-zfs/utils_solaris.go
 create mode 100644 vendor/src/github.com/mistifyio/go-zfs/zfs_notsolaris.go
 create mode 100644 vendor/src/github.com/mistifyio/go-zfs/zfs_solaris.go
 create mode 100644 vendor/src/github.com/mistifyio/go-zfs/zpool_notsolaris.go
 create mode 100644 vendor/src/github.com/mistifyio/go-zfs/zpool_solaris.go
 create mode 100644 vendor/src/github.com/opencontainers/runc/libcontainer/configs/cgroup_solaris.go
 create mode 100644 vendor/src/github.com/opencontainers/runc/libcontainer/console_solaris.go
 create mode 100644 vendor/src/github.com/opencontainers/runc/libcontainer/container_solaris.go
 create mode 100644 vendor/src/github.com/opencontainers/runc/libcontainer/stats_solaris.go
 create mode 100644 vendor/src/github.com/opencontainers/runc/libcontainer/zones/stats.go
 create mode 100644 vendor/src/gopkg.in/fsnotify.v1/fen.go
 create mode 100644 vendor/src/gopkg.in/fsnotify.v1/fen_cgo.go

diff --git a/Dockerfile.solaris b/Dockerfile.solaris
new file mode 100644
index 0000000..a4ad4d4
--- /dev/null
+++ b/Dockerfile.solaris
@@ -0,0 +1,26 @@
+# docker build -t docker:solaris -f Dockerfile.solaris .
+# docker run --rm docker:solaris hack/make.sh dynbinary
+# docker run --rm docker:solaris hack/dind hack/make.sh test-unit  ( NOT TESTED )
+# docker run --rm -v /var/lib/docker docker:solaris hack/dind hack/make.sh dynbinary test-integration-cli  ( NOT TESTED )
+
+# Defines an image that hosts a native Docker build environment for Solaris
+
+FROM solaris:latest
+
+# compile and runtime deps
+# https://github.com/docker/docker/blob/master/project/PACKAGERS.md#build-dependencies
+# https://github.com/docker/docker/blob/master/project/PACKAGERS.md#runtime-dependencies
+RUN pkg install --accept \
+		git \
+		gnu-coreutils \
+		gnu-make \
+		golang \
+		library/golang/* \
+		developer/gcc-*
+
+#ENV AUTO_GOPATH 1
+ENV GOPATH /go/src/github.com/docker/docker/vendor:/go/:/usr/lib/gocode/1.5/
+ENV DOCKER_CROSSPLATFORMS solaris/amd64
+ENV DOCKER_GITCOMMIT 45354ace9209befa0be9d01ee04894727bfde4cb
+WORKDIR /go/src/github.com/docker/docker
+COPY . /go/src/github.com/docker/docker
diff --git a/Makefile b/Makefile
index 7a66015..c218458 100644
--- a/Makefile
+++ b/Makefile
@@ -9,14 +9,21 @@ ifeq ($(DOCKER_OSARCH), linux/arm)
 	DOCKERFILE := Dockerfile.armhf
 else
 ifeq ($(DOCKER_OSARCH), linux/arm64)
-	# TODO .arm64
-	DOCKERFILE := Dockerfile.armhf
+	DOCKERFILE := Dockerfile.aarch64
 else
 ifeq ($(DOCKER_OSARCH), linux/ppc64le)
 	DOCKERFILE := Dockerfile.ppc64le
 else
 ifeq ($(DOCKER_OSARCH), linux/s390x)
 	DOCKERFILE := Dockerfile.s390x
+else
+ifeq ($(DOCKER_OSARCH), windows/amd64)
+	DOCKERFILE := Dockerfile.windows
+else
+ifeq ($(DOCKER_OSARCH), solaris/amd64)
+	DOCKERFILE := Dockerfile.solaris
+endif
+endif
 endif
 endif
 endif
@@ -28,11 +35,15 @@ export DOCKERFILE
 # `docs/sources/contributing/devenvironment.md ` and `project/PACKAGERS.md` have some limited documentation of some of these
 DOCKER_ENVS := \
 	-e BUILDFLAGS \
+	-e KEEPBUNDLE \
+	-e DOCKER_BUILD_GOGC \
+	-e DOCKER_BUILD_PKGS \
 	-e DOCKER_CLIENTONLY \
 	-e DOCKER_DEBUG \
 	-e DOCKER_EXPERIMENTAL \
 	-e DOCKERFILE \
 	-e DOCKER_GRAPHDRIVER \
+	-e DOCKER_INCREMENTAL_BINARY \
 	-e DOCKER_REMAP_ROOT \
 	-e DOCKER_STORAGE_OPTS \
 	-e DOCKER_USERLANDPROXY \
@@ -73,7 +84,17 @@ binary: build
 	$(DOCKER_RUN_DOCKER) hack/make.sh binary
 
 build: bundles
-	docker build -t "$(DOCKER_IMAGE)" -f "$(DOCKERFILE)" .
+ifeq ($(DOCKER_OSARCH), linux/arm)
+	# A few libnetwork integration tests require that the kernel be
+	# configured with "dummy" network interface and has the module
+	# loaded. However, the dummy module is not available by default
+	# on arm images. This ensures that it's built and loaded.
+	echo "Syncing kernel modules"
+	oc-sync-kernel-modules
+	depmod
+	modprobe dummy
+endif
+	docker build ${DOCKER_BUILD_ARGS} -t "$(DOCKER_IMAGE)" -f "$(DOCKERFILE)" .
 
 bundles:
 	mkdir bundles
@@ -87,6 +108,12 @@ deb: build
 docs:
 	$(MAKE) -C docs docs
 
+dynbinary: build
+	$(DOCKER_RUN_DOCKER) hack/make.sh dynbinary
+
+gccgo: build
+	$(DOCKER_RUN_DOCKER) hack/make.sh gccgo
+
 rpm: build
 	$(DOCKER_RUN_DOCKER) hack/make.sh dynbinary build-rpm
 
@@ -106,4 +133,4 @@ test-unit: build
 	$(DOCKER_RUN_DOCKER) hack/make.sh test-unit
 
 validate: build
-	$(DOCKER_RUN_DOCKER) hack/make.sh validate-dco validate-gofmt validate-pkg validate-lint validate-test validate-toml validate-vet validate-vendor
+	$(DOCKER_RUN_DOCKER) hack/make.sh validate-dco validate-default-seccomp validate-gofmt validate-pkg validate-lint validate-test validate-toml validate-vet validate-vendor
diff --git a/api/client/version.go b/api/client/version.go
index a64deef..3000b1a 100644
--- a/api/client/version.go
+++ b/api/client/version.go
@@ -3,7 +3,6 @@ package client
 import (
 	"runtime"
 	"text/template"
-	"time"
 
 	Cli "github.com/docker/docker/cli"
 	"github.com/docker/docker/dockerversion"
@@ -16,8 +15,6 @@ var versionTemplate = `Client:
  Version:      {{.Client.Version}}
  API version:  {{.Client.APIVersion}}
  Go version:   {{.Client.GoVersion}}
- Git commit:   {{.Client.GitCommit}}
- Built:        {{.Client.BuildTime}}
  OS/Arch:      {{.Client.Os}}/{{.Client.Arch}}{{if .Client.Experimental}}
  Experimental: {{.Client.Experimental}}{{end}}{{if .ServerOK}}
 
@@ -25,8 +22,6 @@ Server:
  Version:      {{.Server.Version}}
  API version:  {{.Server.APIVersion}}
  Go version:   {{.Server.GoVersion}}
- Git commit:   {{.Server.GitCommit}}
- Built:        {{.Server.BuildTime}}
  OS/Arch:      {{.Server.Os}}/{{.Server.Arch}}{{if .Server.Experimental}}
  Experimental: {{.Server.Experimental}}{{end}}{{end}}`
 
@@ -58,8 +53,6 @@ func (cli *DockerCli) CmdVersion(args ...string) (err error) {
 			Version:      dockerversion.Version,
 			APIVersion:   cli.client.ClientVersion(),
 			GoVersion:    runtime.Version(),
-			GitCommit:    dockerversion.GitCommit,
-			BuildTime:    dockerversion.BuildTime,
 			Os:           runtime.GOOS,
 			Arch:         runtime.GOARCH,
 			Experimental: utils.ExperimentalBuild(),
@@ -71,19 +64,6 @@ func (cli *DockerCli) CmdVersion(args ...string) (err error) {
 		vd.Server = &serverVersion
 	}
 
-	// first we need to make BuildTime more human friendly
-	t, errTime := time.Parse(time.RFC3339Nano, vd.Client.BuildTime)
-	if errTime == nil {
-		vd.Client.BuildTime = t.Format(time.ANSIC)
-	}
-
-	if vd.ServerOK() {
-		t, errTime = time.Parse(time.RFC3339Nano, vd.Server.BuildTime)
-		if errTime == nil {
-			vd.Server.BuildTime = t.Format(time.ANSIC)
-		}
-	}
-
 	if err2 := tmpl.Execute(cli.out, vd); err2 != nil && err == nil {
 		err = err2
 	}
diff --git a/api/server/router/container/container_routes.go b/api/server/router/container/container_routes.go
index 4e2ffca..e58405b 100644
--- a/api/server/router/container/container_routes.go
+++ b/api/server/router/container/container_routes.go
@@ -27,6 +27,11 @@ import (
 	"golang.org/x/net/websocket"
 )
 
+func timeTrack(start time.Time, name string) {
+	elapsed := time.Since(start)
+	fmt.Printf("%s took %s time\n", name, elapsed)
+}
+
 func (s *containerRouter) getContainersJSON(ctx context.Context, w http.ResponseWriter, r *http.Request, vars map[string]string) error {
 	if err := httputils.ParseForm(r); err != nil {
 		return err
@@ -159,6 +164,7 @@ func (s *containerRouter) getContainersExport(ctx context.Context, w http.Respon
 }
 
 func (s *containerRouter) postContainersStart(ctx context.Context, w http.ResponseWriter, r *http.Request, vars map[string]string) error {
+	defer timeTrack(time.Now(), "postcontainersstart")
 	// If contentLength is -1, we can assumed chunked encoding
 	// or more technically that the length is unknown
 	// https://golang.org/src/pkg/net/http/request.go#L139
@@ -356,6 +362,7 @@ func (s *containerRouter) postContainerUpdate(ctx context.Context, w http.Respon
 }
 
 func (s *containerRouter) postContainersCreate(ctx context.Context, w http.ResponseWriter, r *http.Request, vars map[string]string) error {
+	defer timeTrack(time.Now(), "postcontainerscreate")
 	if err := httputils.ParseForm(r); err != nil {
 		return err
 	}
diff --git a/api/server/server_unix.go b/api/server/server_unix.go
index a4fc639..ea647ff 100644
--- a/api/server/server_unix.go
+++ b/api/server/server_unix.go
@@ -1,4 +1,4 @@
-// +build freebsd linux
+// +build freebsd linux solaris
 
 package server
 
